
const St = imports.gi.St;
const Clutter = imports.gi.Clutter;

const Main = imports.ui.main;
const Tweener = imports.ui.tweener;

var rectangles = new Array();
var counter = 0;

var monitor = Main.layoutManager.primaryMonitor;

function cloneRectangle(original) {
	let clone = createRectangle();

	clone.size = original.size;
	clone.position = original.position;
	clone.color = original.color;

	return clone;
}

function createRectangle() {
	let rectangle = new Clutter.Actor();
	rectangles[counter++] = rectangle;

	rectangle.set_reactive(true);

	rectangle.connect('motion-event', function(actor, source) {
		let clone;

		if (counter < 1000 && source != null) {
			clone = cloneRectangle(rectangle);
			Main.uiGroup.add_actor(clone);
		}

		rectangle.save_easing_state();

		let asx = 95 * Math.random() + 5;
		let asy = 95 * Math.random() + 5;

		let newx = Math.floor(Math.random() * (monitor.width - asx));
		let newy = Math.floor(Math.random() * (monitor.height - asy));

		rectangle.set_position(newx, newy);
		rectangle.set_size(asx, asy);

		rectangle.set_background_color(new Clutter.Color({
			red: 200 * Math.random() + 55,
			blue: 200 * Math.random() + 55,
			green: 200 * Math.random() + 55,
			alpha: 100,
		}));

		rectangle.restore_easing_state();

		if (clone != null) {
			clone.emit("motion-event", null);
		}
	});

	return rectangle;
}

function init() {

}

function enable() {
	let rectangle = createRectangle();
	Main.uiGroup.add_actor(rectangle);
	rectangle.emit("motion-event", null);
}

function disable() {
	for (i = 0; i < counter; i++) {
		let rectangle = rectangles[i];

	    Main.uiGroup.remove_actor(rectangle);
		rectangle.destroy();
	}

	rectangles = new Array();
	counter = 0;
}

